'-----------------------------------------------------
'  
'     3*4 ,  1.0 - 1.6
'  EEPROM 2402
'-----------------------------------------------------
$regfile = "reg51.dat"
$romstart = &H0
$crystal = 11059200
$large
Config Sda = P0.7
Config Scl = P0.6
Config Lcdpin = Pin , Db4 = P0.2 , Db5 = P0.3 , Db6 = P0.4 , Db7 = P0.5 , E = P0.1 , Rs = P0.0
Config Lcd = 16 * 2
Declare Sub I2cbus(adr As Byte , U As Byte , Iz As Byte , W_r As Byte)
Declare Sub Getkbd(kbd As Byte) , Opros(kbd As Byte) , Mem_dn , Mem_up
Declare Sub Wr_mem , Input_kbd , Setvolt(u As Byte , Iz As Byte)
Declare Sub Getcurr(u As Byte , Coun As Byte) , Getcif(kbd As Byte)
Dim Kbd As Byte , Izm As Byte , Iz As Byte , Izf As Byte , Izl As Byte
Dim U As Byte , Uf As Byte , Ul As Byte , Coun As Byte , Dac3 As Byte
Dim Kbd_pr As Byte , Limit As Byte , Pr As Byte , Adr As Byte
Dim R As Const 1 , W As Const 0
Dim W_r As Byte

Main:
  P1 = 127
  P3. 5 = 0
  P3. 6 = 0
  P3. 7 = 0
  Coun = 255
  Pr = 0
  Cls
  Cursor Off Noblink
  Call I2cbus(pr , U , Iz , R)
  Call Setvolt
  Kbd = 12
  Kbd_pr = 12
 Do
  Starrt:
  Call Getkbd
  Coun = Coun + 1
  Call Getcurr
  If Kbd = Kbd_pr Then Goto Starrt                            '     - = 
  Kbd_pr = Kbd                                                '   .
  If Kbd > 11 Then Goto Starrt                                '      
  Sound P1.7 , 300 , 330

  Select Case Kbd
   Case 0 : Gosub Incr0_1a
   Case 1 : Gosub Incr1v
   Case 2 : Gosub Incr0_1v
   Case 3 : Gosub Decr0_1a
   Case 4 : Gosub Decr1v
   Case 5 : Gosub Decr0_1v
   Case 6 : Gosub Incr0_01a
   Case 7 : Call Mem_dn
   Case 8 : Call Mem_up
   Case 9 : Gosub Decr0_01a
   Case 10 : Call Wr_mem
   Case 11 : Call Input_kbd
  End Select
  Loop
End
'-------------------------------------------------------------------------------
 Incr0_01a:
   If Iz > 254 Then Exit Sub
   Iz = Iz + 1
   Pr = 0
   Call Setvolt
 Return
'-------------------------------------------------------------------------------
 Incr1v:
   If U > 245 Then Exit Sub
   U = U + 10
   Pr = 0
   Call Setvolt
 Return
'-------------------------------------------------------------------------------
 Incr0_1v:
   If U > 254 Then Exit Sub
   U = U + 1
   Pr = 0
   Call Setvolt
 Return
'-------------------------------------------------------------------------------
 Decr0_1v:
   If U = 0 Then Exit Sub
   U = U - 1
   Pr = 0
   Call Setvolt
 Return
'-------------------------------------------------------------------------------
 Decr1v:
   If U < 10 Then Exit Sub
   U = U - 10
    Pr = 0
   Call Setvolt
 Return
'-------------------------------------------------------------------------------
 Decr0_01a:
   If Iz < 1 Then Exit Sub
   Iz = Iz - 1
    Pr = 0
   Call Setvolt
 Return
'-------------------------------------------------------------------------------
 Decr0_1a:
   If Iz < 20 Then Exit Sub
   Iz = Iz - 10
    Pr = 0
   Call Setvolt
 Return
'-------------------------------------------------------------------------------
 Incr0_1a:
   If Iz > 245 Then Exit Sub
   Iz = Iz + 10
    Pr = 0
   Call Setvolt
 Return
'-------------------------------------------------------------------------------
Sub Mem_dn
  If Pr < 2 Then
  Pr = 50
  Else
  Pr = Pr - 1
  End If
  Call I2cbus(pr , U , Iz , R)
  Call Setvolt
End Sub
'-------------------------------------------------------------------------------
Sub Mem_up
  If Pr = 50 Then
  Pr = 1
  Else
  Pr = Pr + 1
  End If
  Call I2cbus(pr , U , Iz , R)
  Call Setvolt
End Sub
'-------------------------------------------------------------------------------
Sub Wr_mem
   Cls
   Cursor On Blink
   Lcd Chr(&Ha4) ; Chr(&H61) ; Chr(&Hbe) ; Chr(&Hb8) ; Chr(&H63) ; Chr(&Hc4) ; Chr(&H20) ; Chr(&Hb3) ; " EEPROM?"
   Locate 2 , 1
   Lcd Chr(&H45) ; Chr(&H63) ; Chr(&Hbb) ; Chr(&Hb8) ; Chr(&H20) ; Chr(&He3) ; Chr(&H61) ; Chr(&H20) ; Chr(&Hbd) ; Chr(&H61) ; Chr(&Hb6) ; Chr(&Hbc) ; Chr(&Hb8) ; "- M"
   Limit = 11
   Call Getcif
   If Kbd = 10 Then Call I2cbus(pr , U , Iz , W)
   Cursor Off Noblink
   Call Setvolt
End Sub
'-------------------------------------------------------------------------------
Sub Input_kbd
   Limit = 2
   Cls
   Lcd Chr(&H42) ; Chr(&Hb3) ; Chr(&H65) ; Chr(&He3) ; Chr(&Hb8) ; Chr(&Hbf) ; Chr(&H65) ; Chr(&H20) ; Chr(&Hbd) ; Chr(&H61) ; Chr(&Hbe) ; Chr(&H70) ; Chr(&Hc7) ; Chr(&Hb6) ; Chr(&H65) ; Chr(&H2d)
   Locate 2 , 1
   Lcd Chr(&Hbd) ; Chr(&Hb8) ; Chr(&H65) ; Chr(&H3a)
   Locate 2 , 12
   Lcd "00.0v"
   Locate 2 , 12
   Cursor On Blink
   Call Getcif
   U = Kbd * 100
   Lcd Kbd
   If U = 200 Then
    Limit = 5
   Else
    Limit = 9
   End If
   Locate 2 , 13
   Call Getcif
   Lcd Kbd
   Kbd = Kbd * 10
   U = U + Kbd
   If U = 250 Then
    Limit = 5
   Else
    Limit = 9
   End If
   Locate 2 , 15
   Call Getcif
   Cursor Off Noblink
   Lcd Kbd
   U = U + Kbd
   Waitms 500
   Limit = 2
   Cursor On Blink
   Cls
   Lcd Chr(&Ha4) ; Chr(&Hbd) ; Chr(&H61) ; Chr(&Hc0) ; Chr(&H65) ; Chr(&Hbd) ; Chr(&Hb8) ; Chr(&H65) ; Chr(&H20) ; Chr(&Hbc) ; Chr(&H61) ; Chr(&Hba) ; Chr(&H63) ; Chr(&Hb8) ; Chr(&Hbc) ; Chr(&H2e)
   Locate 2 , 1
   Lcd Chr(&Hbf) ; Chr(&H6f) ; Chr(&Hba) ; Chr(&H61) ; Chr(&H3a)
   Locate 2 , 12
   Lcd "0.00a"
   Locate 2 , 12
   Call Getcif
   Iz = Kbd * 100
   Lcd Kbd
   If Iz = 200 Then
    Limit = 5
   Else
    Limit = 9
   End If
   Locate 2 , 14
   Call Getcif
   Lcd Kbd
   Kbd = Kbd * 10
   Iz = Iz + Kbd
   If Iz = 250 Then
    Limit = 5
   Else
    Limit = 9
   End If
   Locate 2 , 15
   Call Getcif
   Cursor Off Noblink
   Lcd Kbd
   Iz = Iz + Kbd
   Waitms 500
   Call Setvolt
End Sub
'-------------------------------------------------------------------------------
Sub Getkbd(kbd As Byte)
  ' p1.0 - p1.3 - , p1.4 - p1.7 - .
   P1 = &B01110111
   Call Opros
   If Kbd < 3 Then
   P1 = &B01111111
   Exit Sub
   End If
   P1 = &B01101111
   Call Opros
   Kbd = Kbd + 3
   If Kbd < 6 Then
   P1 = &B01111111
   Exit Sub
   End If
   P1 = &B01011111
   Call Opros
   Kbd = Kbd + 6
   If Kbd < 9 Then
   P1 = &B01111111
   Exit Sub
   End If
   P1 = &B00111111
   Call Opros
   Kbd = Kbd + 9
   If Kbd < 12 Then
   P1 = &B01111111
   Exit Sub
   End If
   Kbd = 12
   P1 = &B01111111
End Sub
'-------------------------------------------------------------------------------
Sub Opros(kbd As Byte)
  nop
  nop
  nop
  nop
  nop
  If P1.0 = 0 Then
  Kbd = 0
  Exit Sub
  End If
  If P1.1 = 0 Then
  Kbd = 1
  Exit Sub
  End If
  If P1.2 = 0 Then
  Kbd = 2
  Exit Sub
  End If
  Kbd = 12
End Sub
'------------------------------------------------------------------------------
Sub Getcurr(u As Byte , Coun As Byte)
    If Coun < 255 Then Exit Sub
    For Dac3 = 0 To 255
    P2 = Dac3
    P3.7 = 1
    P3.7 = 0
    If P3.3 = 0 Then Exit For
    Next
    P2 = 0
    P3.7 = 1
    P3.7 = 0
    Izf = Dac3 / 100
    Izm = Dac3 Mod 10
    Izl = Izf * 100
    Izl = Dac3 - Izl
    Izl = Izl / 10
    Locate 1 , 2
    If P3.2 = 0 Then
    Lcd "<"
    Else
    Lcd "="
    End If
    Locate 1 , 12
    Lcd Izf ; "." ; Izl ; Izm ; "a"
    Coun = 0
End Sub
'------------------------------------------------------------------------------
Sub Setvolt(u As Byte , Iz As Byte)
    P2 = U
    P3.5 = 1
    P3.5 = 0
    P3.4 = 0
    P2 = Iz
    P3.6 = 1
    P3.6 = 0
     Uf = U / 10
     Ul = U Mod 10
    Cls
    Lcd "U=" ; Uf ; "." ; Ul ; "v"
    Locate 1 , 10
    Lcd "I=?.??a"
    Locate 2 , 1
    Izf = Iz / 100
    Izm = Iz Mod 10
    Izl = Izf * 100
    Izl = Iz - Izl
    Izl = Izl / 10
    Lcd "Imax=" ; Izf ; "." ; Izl ; Izm ; "a"
    If Pr > 0 Then
    Locate 2 , 12
    Lcd "Pr=" ; Pr
    End If
    Coun = 255
    If Iz = 0 Then
    P3.1 = 0
    Else
    P3.1 = 1
    End If
    Call Getcurr
    Call I2cbus(0 , U , Iz , W)
End Sub
'-------------------------------------------------------------------------------
Sub Getcif(kbd As Byte)

  Staart:
  Call Getkbd
  If Kbd = Kbd_pr Then Goto Staart                            '     - = 
  Kbd_pr = Kbd                                                '   .
  If Kbd > 11 Then Goto Staart                                '      
  Sound P1.7 , 300 , 330
  If Kbd > Limit Then Goto Staart

End Sub
'-------------------------------------------------------------------------------
Sub I2cbus(adr As Byte , U As Byte , Iz As Byte , W_r As Byte)
'  /   I2CBUS
   Adr = Adr * 2
   If W_r = 0 Then                                            ' check if must read or write
      I2cstart                                                ' Start sequence for I2CBUS
      I2cwbyte &HA0
      I2cwbyte Adr
      I2cwbyte U
      I2cwbyte Iz                                             ' value to write
      I2cstop                                                 ' Stop sequence for I2CBUS
      Waitms 20                                               ' delay of 20ms needed by the
                                                              ' EEPROM after each writing
   Else
      I2cstart                                                ' Start sequence for I2CBUS
      I2cwbyte &HA0
      I2cwbyte Adr                                            ' address of EEPROM
      I2cstart                                                ' Repeat start sequence for I2CBUS
      I2cwbyte &HA1                                           ' Communicate the Slave address
      I2crbyte U , Ack
      I2crbyte Iz , Nack                                      ' read value
      I2cstop                                                 ' Stop sequence for I2CBUS
    End If
End Sub
'-------------------------------------------------------------------------------